## hadoop 3.0.0+cdh6.3.2

=== hadoop-hdfs-project/hadoop-hdfs-native-client/src/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

enable_testing()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/../../../hadoop-common-project/hadoop-common)
include(HadoopCommon)

# Check to see if our compiler and linker support the __thread attribute.
# On Linux and some other operating systems, this is a more efficient
# alternative to POSIX thread local storage.
include(CheckCSourceCompiles)
check_c_source_compiles("int main(void) { static __thread int i = 0; return 0; }" HAVE_BETTER_TLS)

# Check to see if we have Intel SSE intrinsics.
check_c_source_compiles("#include <emmintrin.h>\nint main(void) { __m128d sum0 = _mm_set_pd(0.0,0.0); return 0; }" HAVE_INTEL_SSE_INTRINSICS)

set(_FUSE_DFS_VERSION 0.1.0)
configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)

# Check if we need to link dl library to get dlopen.
# dlopen on Linux is in separate library but on FreeBSD its in libc
include(CheckLibraryExists)
check_library_exists(dl dlopen "" NEED_LINK_DL)

if(WIN32)
    # Set the optimizer level.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /O2")
    # Set warning level 4.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W4")
    # Skip "unreferenced formal parameter".
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4100")
    # Skip "conditional expression is constant".
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4127")
    # Skip deprecated POSIX function warnings.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_NONSTDC_NO_DEPRECATE")
    # Skip CRT non-secure function warnings.  If we can convert usage of
    # strerror, getenv and ctime to their secure CRT equivalents, then we can
    # re-enable the CRT non-secure function warnings.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_WARNINGS")
    # Omit unneeded headers.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DWIN32_LEAN_AND_MEAN")
    set(OS_DIR ${CMAKE_SOURCE_DIR}/main/native/libhdfs/os/windows)

    # IMPORTANT: OUT_DIR MUST be relative to maven's
    # project.build.directory (=target) and match dist-copynativelibs
    # in order to be in a release
    set(OUT_DIR bin)
else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
    set(OS_DIR ${CMAKE_SOURCE_DIR}/main/native/libhdfs/os/posix)

    # IMPORTANT: OUT_DIR MUST be relative to maven's
    # project.build.directory (=target) and match dist-copynativelibs
    # in order to be in a release
    set(OUT_DIR native/target/usr/local/lib)
endif()

# Configure JNI.
include(HadoopJNI)

function(build_libhdfs_test NAME LIBRARY)
    set(FILES)
    foreach(FIL ${ARGN})
        if (IS_ABSOLUTE ${FIL})
            list(APPEND FILES ${FIL})
        else()
            list(APPEND FILES ${CMAKE_SOURCE_DIR}/main/native/libhdfs-tests/${FIL})
        endif()
    endforeach()
    add_executable("${NAME}_${LIBRARY}" ${FILES})
endfunction()

function(add_libhdfs_test NAME LIBRARY)
    add_test("test_${NAME}_${LIBRARY}" "${NAME}_${LIBRARY}")
endfunction()

function(link_libhdfs_test NAME LIBRARY)
target_link_libraries("${NAME}_${LIBRARY}" ${LIBRARY} ${ARGN})
endfunction()

add_subdirectory(main/native/libhdfs)
add_subdirectory(main/native/libhdfs-tests)
add_subdirectory(main/native/libhdfs-examples)

# Find Linux FUSE
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(FUSE fuse)
    if(FUSE_FOUND)
        add_subdirectory(main/native/fuse-dfs)
    else()
        message(STATUS "Failed to find Linux FUSE libraries or include files.  Will not build FUSE client.")
        if(REQUIRE_FUSE)
            message(FATAL_ERROR "Required component fuse_dfs could not be built.")
        endif()
    endif(FUSE_FOUND)
else()
    message(STATUS "Non-Linux system detected.  Will not build FUSE client.")
    if(REQUIRE_FUSE)
        message(FATAL_ERROR "Required component fuse_dfs could not be built.")
    endif()
endif()

=== hadoop-yarn-project/hadoop-yarn/hadoop-yarn-server/hadoop-yarn-server-nodemanager/src/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/../../../../../hadoop-common-project/hadoop-common)
include(HadoopCommon)

# Set gtest path
set(GTEST_SRC_DIR ${CMAKE_SOURCE_DIR}/../../../../../hadoop-common-project/hadoop-common/src/main/native/gtest)

# determine if container-executor.conf.dir is an absolute
# path in case the OS we're compiling on doesn't have
# a hook in get_executable. We'll use this define
# later in the code to potentially throw a compile error
string(REGEX MATCH . HCD_ONE "${HADOOP_CONF_DIR}")
string(COMPARE EQUAL ${HCD_ONE} / HADOOP_CONF_DIR_IS_ABS)

set (CMAKE_C_STANDARD 99)

include(CheckIncludeFiles)
check_include_files("sys/types.h;sys/sysctl.h" HAVE_SYS_SYSCTL_H)

include(CheckFunctionExists)
check_function_exists(canonicalize_file_name HAVE_CANONICALIZE_FILE_NAME)
check_function_exists(fcloseall HAVE_FCLOSEALL)
check_function_exists(fchmodat HAVE_FCHMODAT)
check_function_exists(fdopendir HAVE_FDOPENDIR)
check_function_exists(fstatat HAVE_FSTATAT)
check_function_exists(openat HAVE_OPENAT)
check_function_exists(unlinkat HAVE_UNLINKAT)

include(CheckSymbolExists)
check_symbol_exists(sysctl "sys/types.h;sys/sysctl.h" HAVE_SYSCTL)

if(APPLE)
  include_directories( /System/Library/Frameworks )
  find_library(COCOA_LIBRARY Cocoa)
  mark_as_advanced(COCOA_LIBRARY)
  set(EXTRA_LIBS ${COCOA_LIBRARY})
endif(APPLE)

include(CheckCCompilerFlag)

# Building setuid = attempt to enable stack protection.
# assumption here is that the C compiler and the C++
# compiler match.  need both so that gtest gets same
# stack treatment that the real c-e does
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    CHECK_C_COMPILER_FLAG("-fstack-check" STACKRESULT)
    IF(STACKRESULT)
      SET (CMAKE_C_FLAGS "-fstack-check ${CMAKE_C_FLAGS}")
      SET (CMAKE_CXX_FLAGS "-fstack-check ${CMAKE_CXX_FLAGS}")
    ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang" OR
       CMAKE_C_COMPILER_ID STREQUAL "AppleClang")

  # clang is a bit difficult here:
  # - some versions don't support the flag
  # - some versions support the flag, despite not having
  #   the library that is actually required (!)
  # Notably, Xcode is a problem here.
  # In the end, this is needlessly complex. :(

  SET(PRE_SANITIZE ${CMAKE_REQUIRED_FLAGS})
  SET(CMAKE_REQUIRED_FLAGS "-fsanitize=safe-stack ${CMAKE_REQUIRED_FLAGS}")
  CHECK_C_COMPILER_FLAG("" STACKRESULT)
  SET(CMAKE_REQUIRED_FLAGS ${PRE_SANITIZE})
  IF(STACKRESULT)
     SET(CMAKE_C_FLAGS "-fsanitize=safe-stack ${CMAKE_C_FLAGS}")
     SET(CMAKE_CXX_FLAGS "-fsanitize=safe-stack ${CMAKE_CXX_FLAGS}")
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "SunPro")

  # this appears to only be supported on SPARC, for some reason

  CHECK_C_COMPILER_FLAG("-xcheck=stkovf" STACKRESULT)
  IF(STACKRESULT)
    SET (CMAKE_C_FLAGS "-xcheck=stkovf ${CMAKE_C_FLAGS}")
    SET (CMAKE_CXX_FLAGS "-xcheck=stkovf ${CMAKE_CXX_FLAGS}")
  ENDIF()
ENDIF()

IF(NOT STACKRESULT)
   MESSAGE(WARNING "Stack Clash security protection is not suported.")
ENDIF()

function(output_directory TGT DIR)
    set_target_properties(${TGT} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DIR}")
    set_target_properties(${TGT} PROPERTIES
        ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DIR}")
    set_target_properties(${TGT} PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DIR}")
endfunction()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${GTEST_SRC_DIR}/include
    main/native/container-executor
    main/native/container-executor/impl
)
# add gtest as system library to suppress gcc warnings
include_directories(SYSTEM ${GTEST_SRC_DIR}/include)

configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)

add_library(gtest ${GTEST_SRC_DIR}/gtest-all.cc)
set_target_properties(gtest PROPERTIES COMPILE_FLAGS "-w")

add_library(container
    main/native/container-executor/impl/util.c
    main/native/container-executor/impl/configuration.c
    main/native/container-executor/impl/container-executor.c
    main/native/container-executor/impl/get_executable.c
    main/native/container-executor/impl/utils/string-utils.c
    main/native/container-executor/impl/utils/path-utils.c
    main/native/container-executor/impl/modules/cgroups/cgroups-operations.c
    main/native/container-executor/impl/modules/common/module-configs.c
    main/native/container-executor/impl/modules/gpu/gpu-module.c
    main/native/container-executor/impl/utils/docker-util.c
)

add_executable(container-executor
    main/native/container-executor/impl/main.c
)

target_link_libraries(container-executor
    container
)

output_directory(container-executor target/usr/local/bin)

# Test cases
add_executable(test-container-executor
    main/native/container-executor/test/test-container-executor.c
)
target_link_libraries(test-container-executor
    container ${EXTRA_LIBS}
)

output_directory(test-container-executor target/usr/local/bin)

# unit tests for container executor
add_executable(cetest
        main/native/container-executor/impl/get_executable.c
        main/native/container-executor/impl/util.c
        main/native/container-executor/test/test_configuration.cc
        main/native/container-executor/test/test_main.cc
        main/native/container-executor/test/utils/test-string-utils.cc
        main/native/container-executor/test/utils/test-path-utils.cc
        main/native/container-executor/test/modules/cgroups/test-cgroups-module.cc
        main/native/container-executor/test/modules/gpu/test-gpu-module.cc
        main/native/container-executor/test/test_util.cc)
target_link_libraries(cetest gtest container)
output_directory(cetest test)

=== hadoop-hdfs-project/hadoop-hdfs-native-client/src/main/native/libhdfs/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

add_definitions(-DLIBHDFS_DLL_EXPORT)

include_directories(
    include
    ${GENERATED_JAVAH}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${JNI_INCLUDE_DIRS}
    main/native
    main/native/libhdfs
    ${OS_DIR}
)

hadoop_add_dual_library(hdfs
    exception.c
    jni_helper.c
    hdfs.c
    jclasses.c
    ${OS_DIR}/mutexes.c
    ${OS_DIR}/thread_local_storage.c
)
if(NEED_LINK_DL)
   set(LIB_DL dl)
endif()

hadoop_target_link_dual_libraries(hdfs
    ${JAVA_JVM_LIBRARY}
    ${LIB_DL}
    ${OS_LINK_LIBRARIES}
)

hadoop_dual_output_directory(hdfs ${OUT_DIR})
set(LIBHDFS_VERSION "0.0.0")
set_target_properties(hdfs PROPERTIES
    SOVERSION ${LIBHDFS_VERSION})

build_libhdfs_test(test_libhdfs_ops hdfs_static test_libhdfs_ops.c)
link_libhdfs_test(test_libhdfs_ops hdfs_static native_mini_dfs ${JAVA_JVM_LIBRARY})
add_libhdfs_test(test_libhdfs_ops hdfs_static)

build_libhdfs_test(test_libhdfs_threaded hdfs_static expect.c test_libhdfs_threaded.c ${OS_DIR}/thread.c)
link_libhdfs_test(test_libhdfs_threaded hdfs_static native_mini_dfs)
add_libhdfs_test(test_libhdfs_threaded hdfs_static)

if (NOT WIN32)
build_libhdfs_test(test_libhdfs_zerocopy hdfs_static expect.c test_libhdfs_zerocopy.c)
link_libhdfs_test(test_libhdfs_zerocopy hdfs_static native_mini_dfs ${OS_LINK_LIBRARIES})
add_libhdfs_test(test_libhdfs_zerocopy hdfs_static)
endif()

# Skip vecsum on Windows.  This could be made to work in the future by
# introducing an abstraction layer over the sys/mman.h functions.
if(NOT WIN32)
    build_libhdfs_test(test_libhdfs_vecsum hdfs vecsum.c)
    if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
        link_libhdfs_test(test_libhdfs_vecsum hdfs pthread)
    else()
        link_libhdfs_test(test_libhdfs_vecsum hdfs pthread rt)
    endif()
endif()

## hadoop 3.0.0+cdh6.3.0

=== debian/changelog ===
hadoop (3.0.0+cdh6.3.0-1279813.meta1) stable; urgency=medium

  * Fix package build for MetaCentrum.

 -- František Dvořák <valtri@civ.zcu.cz>  Fri, 23 Aug 2019 00:00:00 +0200

hadoop (3.0.0+cdh6.3.0-1279813) cloudera; urgency=medium

  * Please see git repos.

 -- MAINTAINER <jenkins@cldrn-ub1604-ec2-c5d-18xlarge-spotblk-0483.vpc.cloudera.com>  Thu, 18 Jul 2019 10:08:11 -0700

=== debian/control ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

Source: hadoop
Section: misc
Priority: extra
Maintainer: Cloudera Inc. <https://issues.cloudera.org>
Build-Depends: debhelper (>= 7.0.50~), liblzo2-dev, libzip-dev, sharutils, g++ (>= 4), libfuse-dev, libssl-dev, cmake, pkg-config, python, automake, autoconf (>= 2.61), make, libsnappy1-dev | libsnappy-dev, libtool, curl, libbz2-dev, libzstd-dev, libisal-dev, pigz
Standards-Version: 3.8.0
Homepage: http://hadoop.apache.org/core/

Package: hadoop
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, bigtop-utils (>= 0.7), zookeeper (>= 3.4.0), psmisc, netcat-openbsd, avro-libs, parquet
Description: A software platform for processing vast amounts of data
 Hadoop is a software platform that lets one easily write and
 run applications that process vast amounts of data.
 .
 Here's what makes Hadoop especially useful:
  * Scalable: Hadoop can reliably store and process petabytes.
  * Economical: It distributes the data and processing across clusters
                of commonly available computers. These clusters can number
                into the thousands of nodes.
  * Efficient: By distributing the data, Hadoop can process it in parallel
               on the nodes where the data is located. This makes it
               extremely rapid.
  * Reliable: Hadoop automatically maintains multiple copies of data and
              automatically redeploys computing tasks based on failures.
 .
 Hadoop implements MapReduce, using the Hadoop Distributed File System (HDFS).
 MapReduce divides applications into many small blocks of work. HDFS creates
 multiple replicas of data blocks for reliability, placing them on compute
 nodes around the cluster. MapReduce can then process the data where it is
 located.

Package: hadoop-hdfs
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, bigtop-utils (>= 0.7), hadoop (= ${source:Version}), bigtop-jsvc
Description: The Hadoop Distributed File System
 Hadoop Distributed File System (HDFS) is the primary storage system used by
 Hadoop applications. HDFS creates multiple replicas of data blocks and
 distributes them on cluster hosts to enable reliable and extremely rapid
 computations.

Package: hadoop-yarn
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, bigtop-utils (>= 0.7), hadoop (= ${source:Version}), avro-libs, zookeeper
Description: The Hadoop NextGen MapReduce (YARN)
 YARN (Hadoop NextGen MapReduce) is a general purpose data-computation framework.
 YARN splits up the functionalities of JobTracker, resource management, 
 job scheduling, and job monitoring into separate daemons called 
 ResourceManager and NodeManager.
 .
 ResourceManager is the ultimate authority that arbitrates resources 
 among all applications in the system. NodeManager is a per-host worker
 that manages allocation of computational resources on a single host. 
 Both daemons work in support of ApplicationMaster (AM).
 .
 ApplicationMaster is a framework-specific library that negotiates resources 
 from ResourceManager and works with NodeManager(s) to execute and monitor 
 the tasks.

Package: hadoop-mapreduce
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, bigtop-utils (>= 0.7), hadoop-yarn (= ${source:Version}), avro-libs, zookeeper, hadoop (= ${source:Version})
Description: The Hadoop MapReduce (MRv2)
 Hadoop MapReduce is a programming model and software framework for
 writing applications that rapidly process vast amounts of data
 in parallel on large clusters of hosts.

Package: hadoop-hdfs-fuse
Architecture: i386 amd64
Depends: ${shlibs:Depends}, hadoop-hdfs (= ${source:Version}), hadoop-client (= ${source:Version}), libfuse2, fuse-utils|fuse, bigtop-utils (>= 0.7)
Enhances: hadoop
Description: HDFS exposed over a Filesystem in Userspace
 These projects (enumerated below) allow HDFS to be mounted (on most flavors 
 of Unix) as a standard file system using the mount command. Once mounted, the
  user can operate on an instance of hdfs using standard Unix utilities such 
 as 'ls', 'cd', 'cp', 'mkdir', 'find', 'grep', or use standard Posix libraries 
 like open, write, read, close from C, C++, Python, Ruby, Perl, Java, bash, etc.

Package: hadoop-doc
Architecture: all
Section: doc
Description: Documentation for Hadoop
 This package contains the Java Documentation for Hadoop and its relevant
 APIs.

Package: hadoop-conf-pseudo
Architecture: all
Depends: hadoop (= ${source:Version}), hadoop-hdfs-namenode (= ${source:Version}),
         hadoop-hdfs-datanode (= ${source:Version}), hadoop-hdfs-secondarynamenode (= ${source:Version}),
         hadoop-yarn-resourcemanager (= ${source:Version}), hadoop-yarn-nodemanager (= ${source:Version}),
         hadoop-mapreduce-historyserver (= ${source:Version})
Description: Pseudo-distributed Hadoop configuration
 Contains configuration files for a "pseudo-distributed" Hadoop deployment.
 In this mode, each of the hadoop components runs as a separate Java process,
 but all on the same machine.

Package: hadoop-mapreduce-historyserver
Architecture: all
Depends: hadoop-mapreduce (= ${source:Version}), hadoop-hdfs (= ${source:Version})
Description: MapReduce History Server
 The History server keeps records of the different activities being performed 
 on a Apache Hadoop cluster.

Package: hadoop-yarn-nodemanager
Architecture: all
Depends: hadoop-yarn (= ${source:Version})
Description: Node manager for Hadoop
 The NodeManager is the per-machine framework agent who is responsible for
 containers, monitoring their resource usage (cpu, memory, disk, network) and
 reporting the same to the ResourceManager/Scheduler.

Package: hadoop-yarn-resourcemanager
Architecture: all
Depends: hadoop-yarn (= ${source:Version})
Description: Resource manager for Hadoop
 The resource manager manages the global assignment of compute resources to applications.

Package: hadoop-yarn-proxyserver
Architecture: all
Depends: hadoop-yarn (= ${source:Version})
Description: Web proxy for YARN
 The web proxy server sits in front of the YARN application master web UI.

Package: hadoop-yarn-timelinereader
Architecture: all
Depends: hadoop-yarn (= ${source:Version})
Description: Timelinereader for Hadoop
 The timelinereader that serves requests of metrics or events of hadoop application.

Package: hadoop-hdfs-namenode
Architecture: all
Depends: hadoop-hdfs (= ${source:Version})
Description: Name Node for Hadoop
 The Hadoop Distributed Filesystem (HDFS) requires one unique server, the
 namenode, which manages the block locations of files on the filesystem.

Package: hadoop-hdfs-secondarynamenode
Architecture: all
Depends: hadoop-hdfs (= ${source:Version})
Description: Secondary Name Node for Hadoop
 The Secondary Name Node is responsible for checkpointing file system images.
 It is _not_ a failover pair for the namenode, and may safely be run on the
 same machine.

Package: hadoop-hdfs-zkfc
Architecture: all
Depends: hadoop-hdfs (= ${source:Version})
Description: Hadoop HDFS failover controller
 The Hadoop HDFS failover controller is a ZooKeeper client which also
 monitors and manages the state of the NameNode. Each of the machines
 which runs a NameNode also runs a ZKFC, and that ZKFC is responsible
 for: Health monitoring, ZooKeeper session management, ZooKeeper-based
 election.

Package: hadoop-hdfs-journalnode
Provides: hadoop-hdfs-journalnode
Architecture: all
Depends: hadoop-hdfs (= ${source:Version})
Description: Hadoop HDFS JournalNode 
 The HDFS JournalNode is responsible for persisting NameNode edit logs. 
 In a typical deployment the JournalNode daemon runs on at least three 
 separate machines in the cluster.

Package: hadoop-hdfs-datanode
Architecture: all
Depends: hadoop-hdfs (= ${source:Version})
Description: Data Node for Hadoop
 The Data Nodes in the Hadoop Cluster are responsible for serving up
 blocks of data over the network to Hadoop Distributed Filesystem
 (HDFS) clients.

Package: hadoop-hdfs-nfs3
Architecture: all
Depends: hadoop-hdfs (= ${source:Version}), rpcbind
Description: Hadoop HDFS NFS v3 gateway service

Package: libhdfs0
Architecture: any
Depends: hadoop (= ${source:Version}), ${shlibs:Depends}
Description: JNI Bindings to access Hadoop HDFS from C
 See http://wiki.apache.org/hadoop/LibHDFS
 
Package: hadoop-kms
Architecture: all
Depends: hadoop-client (= ${source:Version})
Description: KMS for Hadoop
   Hadoop KMS is a cryptographic Key Management Server based on Hadoop's KeyProvider API.

Package: hadoop-kms-server
Architecture: all
Depends: hadoop-kms (= ${source:Version})
Description: KMS for Hadoop
 Bundles init scripts for KMS.

Package: libhdfs0-dev
Architecture: any
Section: libdevel
Depends: hadoop (= ${source:Version}), libhdfs0 (= ${binary:Version})
Description: Development support for libhdfs0
 Includes examples and header files for accessing HDFS from C

Package: hadoop-httpfs
Architecture: all
Depends: hadoop (= ${source:Version}), hadoop-client (= ${source:Version}), hadoop-hdfs (= ${source:Version}), avro-libs, zookeeper
Description: HTTPFS for Hadoop
  The server providing HTTP REST API support for the complete FileSystem/FileContext
  interface in HDFS.

Package: hadoop-client
Architecture: all
Depends: hadoop (= ${source:Version}), hadoop-hdfs (= ${source:Version}), zookeeper,
         hadoop-yarn (= ${source:Version}), hadoop-mapreduce (= ${source:Version}), avro-libs
Description: Hadoop client side dependencies
 Installation of this package will provide you with all the dependencies for Hadoop clients.

=== debian/rules ===
#!/usr/bin/make -f
export COMPONENT_HASH=7f07ef8e6df428a8eb53009dc8d9a249dbbb50ad
 HADOOP_VERSION=3.0.0+cdh6.3.0
 HADOOP_PATCHED_VERSION=3.0.0-cdh6.3.0
 HADOOP_BASE_VERSION=3.0.0
 HADOOP_RELEASE=1279813
 CDH_CUSTOMER_PATCH=p0
 CDH_PARCEL_CUSTOM_VERSION=3.0.0+cdh6.3.0-1279813.bionic

# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh $@

hadoop_version=${HADOOP_BASE_VERSION}

ifeq (${DEB_BUILD_ARCH},amd64)
  native_dir=Linux-amd64-64
endif
ifeq (${DEB_BUILD_ARCH},i386)
  native_dir=Linux-i386-32
endif

override_dh_auto_build:
	env FULL_VERSION=${HADOOP_PATCHED_VERSION} HADOOP_VERSION=${HADOOP_VERSION} HADOOP_ARCH=${native_dir} \
	    bash debian/do-component-build

hadoop_svcs=hdfs-namenode hdfs-secondarynamenode hdfs-datanode hdfs-zkfc hdfs-journalnode hdfs-nfs3\
            yarn-resourcemanager yarn-nodemanager yarn-proxyserver \
            mapreduce-historyserver httpfs \
            kms-server

$(hadoop_svcs): debian/init.d.tmpl
	bash $< debian/hadoop-$@.svc deb debian/hadoop-$@.init
	cp debian/$(firstword $(subst -, ,$@)).default debian/tmp/etc/default/hadoop-$@
	echo /etc/default/hadoop-$@ >> debian/hadoop-$@.install
	# FIXME: workaround for BIGTOP-105
	[ -f debian/hadoop-$@.postinst ] || cp debian/hadoop.daemon.postinst.tpl debian/hadoop-$@.postinst
	sed -i -e "s|@HADOOP_DAEMON@|$@|" debian/hadoop-$@.postinst

override_dh_auto_install:
	bash debian/install_hadoop.sh \
	  --prefix=debian/tmp/ \
	  --distro-dir=debian \
          --source-dir=${PWD} \
          --build-dir=${PWD}/build/hadoop-${HADOOP_PATCHED_VERSION} \
          --hadoop-version=${HADOOP_PATCHED_VERSION} \
	  --httpfs-dir=debian/tmp/usr/lib/hadoop-httpfs \
	  --httpfs-etc-dir=debian/tmp/etc/hadoop-httpfs \
	  --system-lib-dir=debian/tmp/usr/lib/ \
	  --system-libexec-dir=debian/tmp/usr/lib/hadoop/libexec/ \
	  --system-include-dir=debian/tmp/usr/include \
	  --doc-dir=debian/tmp/usr/share/doc/hadoop-doc \
          --man-dir=debian/tmp/usr/share/man \
	  --example-dir=debian/tmp/usr/share/doc/hadoop/examples \
	  --native-build-string=${native_dir} \
	  --installed-lib-dir=/usr/lib/hadoop \
	  --kms-dir=debian/tmp/usr/lib/hadoop-kms \
	  --kms-etc-dir=debian/tmp/etc/hadoop-kms
	# Forcing Zookeeper dependency to be on the packaged jar
	ln -sf /usr/lib/zookeeper/zookeeper.jar debian/tmp/usr/lib/hadoop/lib/zookeeper*.jar
	# Workaround for BIGTOP-583
	rm -f debian/tmp/usr/lib/hadoop*/lib/slf4j-log4j12-*.jar
	ln -fs /usr/lib/zookeeper/lib/slf4j-log4j12.jar debian/tmp/usr/lib/hadoop/lib/slf4j-log4j12.jar
	# FIXME: BIGTOP-463
	mkdir -p debian/tmp/etc/default
	echo 'export JSVC_HOME=/usr/lib/bigtop-utils' >> debian/hadoop.default
	cp debian/hadoop.default debian/tmp/etc/default/hadoop
	# Refactored from install-arch
	cp debian/hadoop-fuse.default debian/tmp/etc/default/hadoop-fuse
	mkdir -p debian/tmp/etc/security/limits.d
	cp debian/hdfs.conf debian/yarn.conf debian/mapreduce.conf debian/tmp/etc/security/limits.d
	# MR1 hack
	cp debian/mapreduce.conf debian/tmp/etc/security/limits.d/mapred.conf
	# Copy in defaults for KMS service
	cp debian/kms.default debian/tmp/etc/default/hadoop-kms

override_dh_install: $(hadoop_svcs)
	dh_install
	# Drop misc fuse_dfs directories
	rm -Rf debian/hadoop/usr/lib/hadoop/bin/fuse_dfs 
	rm -Rf debian/hadoop/usr/lib/hadoop/contrib/fuse-dfs
	rm -Rf debian/hadoop/usr/lib/hadoop/hdfs/contrib/fuse-dfs

override_dh_builddeb:
	dh_builddeb -- -Zgzip

override_dh_strip_nondeterminism:
	# Disable dh_strip_nondeterminism to speed up the build

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## hadoop 3.0.0+cdh6.3.2

=== debian/changelog ===
hadoop (3.0.0+cdh6.3.2-1605554) cloudera; urgency=medium

  * Please see git repos.

 -- MAINTAINER <jenkins@cldrn-ub1604-ec2-c5d-18xlarge-spotblk-10a0.vpc.cloudera.com>  Fri, 08 Nov 2019 05:47:37 -0800

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 Section: misc
 Priority: extra
 Maintainer: Cloudera Inc. <https://issues.cloudera.org>
-Build-Depends: debhelper (>= 7.0.50~), liblzo2-dev, libzip-dev, sharutils, g++ (>= 4), libfuse-dev, libssl-dev, cmake, pkg-config, python, automake, autoconf (>= 2.61), make, libsnappy1-dev | libsnappy-dev, libtool, curl, libbz2-dev, libzstd-dev, libisal-dev, pigz
+Build-Depends: debhelper (>= 7.0.50~), liblzo2-dev, libzip-dev, sharutils, g++ (>= 4), libfuse-dev, libssl-dev, cmake, pkg-config, python, automake, autoconf (>= 2.61), make, libsnappy1-dev | libsnappy-dev, libtool
 Standards-Version: 3.8.0
 Homepage: http://hadoop.apache.org/core/

=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,11 @@
 #!/usr/bin/make -f
-export COMPONENT_HASH=7f07ef8e6df428a8eb53009dc8d9a249dbbb50ad
- HADOOP_VERSION=3.0.0+cdh6.3.0
- HADOOP_PATCHED_VERSION=3.0.0-cdh6.3.0
+export COMPONENT_HASH=9aff20de3b5ecccf3c19d57f71b214fb4d37ee89
+ HADOOP_VERSION=3.0.0+cdh6.3.2
+ HADOOP_PATCHED_VERSION=3.0.0-cdh6.3.2
  HADOOP_BASE_VERSION=3.0.0
- HADOOP_RELEASE=1279813
+ HADOOP_RELEASE=1605554
  CDH_CUSTOMER_PATCH=p0
- CDH_PARCEL_CUSTOM_VERSION=3.0.0+cdh6.3.0-1279813.bionic
+ CDH_PARCEL_CUSTOM_VERSION=3.0.0+cdh6.3.2-1605554.bionic
 
 # Licensed to the Apache Software Foundation (ASF) under one or more
 # contributor license agreements.  See the NOTICE file distributed with
